<CsoundSynthesizer>
<CsOptions>
-m0 -n -d
</CsOptions>
<CsInstruments>

/*Basic examples for Strays - UDOs for using strings as arrays in Csound.
ALL EXEMPLES REQUIRE THE NEW PARSER (default in Csound 5.16 or higher)!
More examples and extended documentation can be found at www.csounds.com/udo
   joachim heintz feb 2012*/

#include "strays.inc"

  instr title
prints "\n\n\n********************************************************************************\n"
prints "********************************************************************************\n"
prints "  Basic examples for Strays - UDOs for using strings as arrays in Csound.\n"
prints "  ALL EXEMPLES REQUIRE THE NEW PARSER (default in Csound 5.16 or higher)!\n"
prints "  More examples and complete documentation can be found at www.csounds.com/udo\n"
prints "       joachim heintz feb 2012\n"
prints "********************************************************************************\n"
prints "********************************************************************************\n\n"
  endin

  instr StrayLen_Ex
prints "\n****************************************************************************\n"
prints "**********************************StrayLen**********************************\n"
prints "****************************************************************************\n"
          prints      "   <ilen  StrayLen  Stray[, isep1[, isep2]]>\n"
          prints      "   <gets the length of a stray>\n"
Stray     =           "a b c d e"
ilen      StrayLen    Stray
          printf_i    "\nStray = '%s'\n isep1/isep2 = default (space/tab)\n   ilen -> %d\n", 1, Stray, ilen
Stray     =           "FileA.wav|F i l e B.wav|FileC.wav"
ilen      StrayLen    Stray, 124
          printf_i    "\nStray = '%s'\n isep1/isep2=124 ('|')\n   ilen -> %d\n", 1, Stray, ilen
          prints      "\n"
  endin


  instr StrayGetEl_Ex
prints "\n****************************************************************************\n"
prints "*********************************StrayGetEl*********************************\n"
prints "****************************************************************************\n"
          prints      "   <Sel  StrayGetEl  Stray, ielindx[, isep1[, isep2]]>\n"
          prints      "   <gets an element at a certain position ielindx>\n"
Stray     =           "The 	ASCII code of a comma (,) is 44"
ielindx   =           2
Sel       StrayGetEl  Stray, ielindx
          printf_i    "\nStray = '%s'\n ielindx = %d\n isep1/isep2 = default (space/tab)\n   Sel -> '%s'\n", 1, Stray, ielindx, Sel
Stray     =           "Audio 01.wav|Audio 02.wav|Audio 03.wav|Audio 04.wav"
ielindx   =           1
isep1     =           124
Sel       StrayGetEl  Stray, ielindx, isep1
          printf_i    "\nStray = '%s'\n ielindx = %d\n isep1/isep2 = %d ('|')\n   Sel -> '%s'\n", 1, Stray, ielindx, isep1, Sel
Stray     =           "Audio 01.wav|Audio 02.wav|Audio 03.wav|Audio 04.wav"
ielindx   =           1
isep1     =           124
isep2     =           32
Sel       StrayGetEl  Stray, ielindx, isep1, isep2
          printf_i    "\nStray = '%s'\n ielindx = %d\n isep1 = %d ('|')\n isep2 = %d (space)\n   Sel -> '%s'\n", 1, Stray, ielindx, isep1, isep2, Sel
          prints      "\n"
  endin


  instr StrayGetNum_Ex
prints "\n****************************************************************************\n"
prints "********************************StrayGetNum*********************************\n"
prints "****************************************************************************\n"
          prints      "   <inum  StrayGetNum  Stray, ielindx[, isep1[, isep2]]>\n"
          prints      "   <gets an number at a certain position ielindx>\n"
Stray     =           "The 	ASCII code of a comma (,) is 44"
ielindx   =           8
inum      StrayGetNum Stray, ielindx
          printf_i    "\nStray = '%s'\n ielindx = %d\n isep1/isep2 = default (space/tab)\n   inum -> '%f'\n", 1, Stray, ielindx, inum
Stray     =           "44,33.22,11"
ielindx   =           1
isep1     =           44
inum      StrayGetNum Stray, ielindx, isep1
          printf_i    "\nStray = '%s'\n ielindx = %d\n isep1 = %d (comma)\n   inum -> '%f'\n", 1, Stray, ielindx, isep1, inum
Stray     =           "44, 33.22, 11"
ielindx   =           1
isep1     =           44
isep2     =           32
inum      StrayGetNum Stray, ielindx, isep1, isep2
          printf_i    "\nStray = '%s'\n ielindx = %d\n isep1 = %d (comma)\n isep2 = %d (space)\n   inum -> '%f'\n", 1, Stray, ielindx, isep1, isep2, inum
          prints      "\n"
  endin
  
  
  instr StrayElMem_Ex
prints "\n****************************************************************************\n"
prints "*********************************StrayElMem*********************************\n"
prints "****************************************************************************\n"
          prints      "   <ipos  StrayElMem  Stray, Stest[, isep1[, isep2]]>\n"
          prints      "   <returns the position of Stest in Stray>\n"
Stray     =           "sdhgf elh 4 876 a"
Stest     =           "a"
ipos      StrayElMem  Stray, Stest
          printf_i    "\nStray = '%s'\n Stest = '%s'\n isep1/isep2 = default (space/tab)\n   ipos -> '%d'\n", 1, Stray, Stest, ipos
Stray     =           "sdhgf, a, elh,  4,  876"
Stest     =           "a"
isep1     =           44
ipos      StrayElMem  Stray, Stest, isep1
          printf_i    "\nStray = '%s'\n Stest = '%s'\n isep1/isep2 = %d (comma)\n   ipos -> '%d'\n", 1, Stray, Stest, isep1, ipos
Stray     =           "sdhgf,a,elh,4,876"
Stest     =           "a"
isep1     =           44
ipos      StrayElMem  Stray, Stest, isep1
          printf_i    "\nStray = '%s'\n Stest = '%s'\n isep1/isep2 = %d (comma)\n   ipos -> '%d'\n", 1, Stray, Stest, isep1, ipos
Stray     =           "sdhgf, a, elh,  4,  876"
Stest     =           "a"
isep1     =           44
isep2     =           32
ipos      StrayElMem  Stray, Stest, isep1, isep2
          printf_i    "\nStray = '%s'\n Stest = '%s'\n isep1 = %d (comma)\n isep2 = %d (space)\n   ipos -> '%d'\n", 1, Stray, Stest, isep1, isep2, ipos
          prints      "\n"
  endin


  instr StrayNumMem_Ex
prints "\n****************************************************************************\n"
prints "********************************StrayNumMem*********************************\n"
prints "****************************************************************************\n"
          prints      "   <ipos  StrayNumMem  Stray, inum[, isep1[, isep2]]>\n"
          prints      "   <returns the position of inum in Stray>\n"
inum      =           4
Stray     =           "sdhgfa elh 4 876"
ipos      StrayNumMem Stray, inum
          printf_i    "\nStray = '%s'\n inum = %d\n isep1/isep2 = default (space/tab)\n   ipos -> '%d'\n", 1, Stray, inum, ipos
Stray     =           "sdhgf,a,elh,4,876"
isep1     =           44
ipos      StrayNumMem Stray, inum, isep1
          printf_i    "\nStray = '%s'\n inum = %d\n isep1/isep2 = %d (comma)\n   ipos -> '%d'\n", 1, Stray, inum, isep1, ipos
Stray     =           "sdhgf, a, elh, 4, 876"
isep1     =           44
ipos      StrayNumMem Stray, inum, isep1
          printf_i    "\nStray = '%s'\n inum = %d\n isep1/isep2 = %d (comma)\n   ipos -> '%d'\n", 1, Stray, inum, isep1, ipos
Stray     =           "sdhgf, a, elh, 4, 876"
isep1     =           44
isep2     =           32
ipos      StrayNumMem Stray, inum, isep1, isep2
          printf_i    "\nStray = '%s'\n inum = %d\n isep1 = %d (comma)\n isep2 = %d (space)\n   ipos -> '%d'\n", 1, Stray, inum, isep1, isep2, ipos
          prints      "\n"
  endin


  instr StraySetEl_Ex
prints "\n****************************************************************************\n"
prints "*********************************StraySetEl*********************************\n"
prints "****************************************************************************\n"
          prints      "   <Sres  StraySetEl  Stray, Sin[, ielindx[, isep1[, isep2[,isepOut]]]]>\n"
          prints      "   <inserts Sin at the position ielindx in Stray>\n"
Sin       =           "go"
ielindx   =           2
Stray     =           "a b c d e"
Sres      StraySetEl  Stray, Sin, ielindx
          printf_i    "\nStray = '%s'\n Sin = '%s'\n ielindx = %d\n isep1/isep2 = default (space/tab)\n isepOut = default (isep1)\n   Sres -> '%s'\n", 1, Stray, Sin, ielindx, Sres
Stray     =           "a,b,c,d,e"
isep1     =           44
Sres      StraySetEl  Stray, Sin, ielindx, isep1
          printf_i    "\nStray = '%s'\n Sin = '%s'\n ielindx = %d\n isep1/isep2 = 44 (comma)\n isepOut = default (isep1)\n   Sres -> '%s'\n", 1, Stray, Sin, ielindx, Sres
Stray     =           "a, b c, d e"
isep1     =           44
Sres      StraySetEl  Stray, Sin, ielindx, isep1
          printf_i    "\nStray = '%s'\n Sin = '%s'\n ielindx = %d\n isep1/isep2 = 44 (comma)\n isepOut = default (isep1)\n   Sres -> '%s'\n", 1, Stray, Sin, ielindx, Sres
Stray     =           "a, b c, d e"
isep1     =           44
isep2     =           32
Sres      StraySetEl  Stray, Sin, ielindx, isep1, isep2
          printf_i    "\nStray = '%s'\n Sin = '%s'\n ielindx = %d\n isep1 = 44 (comma)\n isep2 = 32 (space)\n isepOut = default (isep1)\n   Sres -> '%s'\n", 1, Stray, Sin, ielindx, Sres
Stray     =           "a, b c, d e"
isep1     =           32
isep2     =           44
Sres      StraySetEl  Stray, Sin, ielindx, isep1, isep2
          printf_i    "\nStray = '%s'\n Sin = '%s'\n ielindx = %d\n isep1 = 32 (space)\n isep2 = 44 (comma)\n isepOut = default (isep1)\n   Sres -> '%s'\n", 1, Stray, Sin, ielindx, Sres
Stray     =           "a,b| c, d e"
isep1     =           32
isep2     =           124
isepOut   =           44
Sres      StraySetEl  Stray, Sin, ielindx, isep1, isep2, isepOut
          printf_i    "\nStray = '%s'\n Sin = '%s'\n ielindx = %d\n isep1 = 32 (space)\n isep2 = 124 ('|')\n isepOut = 44 (comma)\n   Sres -> '%s'\n", 1, Stray, Sin, ielindx, Sres
          prints      "\n"
  endin

  
  instr StraySetNum_Ex
prints "\n****************************************************************************\n"
prints "********************************StraySetNum*********************************\n"
prints "****************************************************************************\n"
          prints      "   <Sres  StraySetNum  Stray, inum[, ielindx[, isep1[, isep2[,isepOut]]]]>\n"
          prints      "   <inserts inum at the position ielindx in Stray>\n"
inum      =           3
ielindx   =           2
Stray     =           "1 2 4 5"
Sres      StraySetNum Stray, inum, ielindx
          printf_i    "\nStray = '%s'\n inum = %d\n ielindx = %d\n isep1/isep2 = default (space/tab)\n isepOut = default (isep1)\n   Sres -> '%s'\n", 1, Stray, inum, ielindx, Sres
Stray     =           "1,2,4,5"
isep1     =           44
Sres      StraySetNum Stray, inum, ielindx, isep1
          printf_i    "\nStray = '%s'\n inum = %d\n ielindx = %d\n isep1/isep2 = 44 (comma)\n isepOut = default (isep1)\n   Sres -> '%s'\n", 1, Stray, inum, ielindx, Sres
Stray     =           "1, 2, 4, 5"
isep1     =           44
isep2     =           32
Sres      StraySetNum Stray, inum, ielindx, isep1, isep2
          printf_i    "\nStray = '%s'\n inum = %d\n ielindx = %d\n isep1= 44 (comma)\n isep2 = 32 (space)\n isepOut = default (isep1)\n   Sres -> '%s'\n", 1, Stray, inum, ielindx, Sres
Stray     =           "1, 2, 4, 5"
isep1     =           32
isep2     =           44
Sres      StraySetNum Stray, inum, ielindx, isep1, isep2
          printf_i    "\nStray = '%s'\n inum = %d\n ielindx = %d\n isep1= 32 (space)\n isep2 = 44 (comma)\n isepOut = default (isep1)\n   Sres -> '%s'\n", 1, Stray, inum, ielindx, Sres
Stray     =           "1, 2, 4, 5"
isep1     =           32
isep2     =           44
isepOut   =           44
Sres      StraySetNum Stray, inum, ielindx, isep1, isep2, isepOut
          printf_i    "\nStray = '%s'\n inum = %d\n ielindx = %d\n isep1= 32 (space)\n isep2 = 44 (comma)\n isepOut = 44 (comma)\n   Sres -> '%s'\n", 1, Stray, inum, ielindx, Sres
          prints      "\n"
  endin


  instr StrayRev_Ex
prints "\n****************************************************************************\n"
prints "**********************************StrayRev**********************************\n"
prints "****************************************************************************\n"
          prints      "   <Sres  StrayRev  Stray[, isep1[, isep2[,isepOut]]]>\n"
          prints      "   <reverses the elements in Stray>\n"
Stray     =           "a b c d e"
Sres      StrayRev    Stray
          printf_i    "\nStray = '%s'\n isep1/isep2 = default (space/tab)\n isepOut = default (isep1)\n   Sres -> '%s'\n", 1, Stray, Sres
Stray     =           "a,b,c,d,e"
isep1     =           44
Sres      StrayRev    Stray, isep1
          printf_i    "\nStray = '%s'\n isep1/isep2 = 44 (comma)\n isepOut = default (isep1)\n   Sres -> '%s'\n", 1, Stray, Sres
Stray     =           "a, b, c, d, e"
isep1     =           44
Sres      StrayRev    Stray, isep1
          printf_i    "\nStray = '%s'\n isep1/isep2 = 44 (comma)\n isepOut = default (isep1)\n   Sres -> '%s'\n", 1, Stray, Sres
Stray     =           "a, b, c, d, e"
isep1     =           44
isep2     =           32
Sres      StrayRev    Stray, isep1, isep2
          printf_i    "\nStray = '%s'\n isep1 = 44 (comma)\n isep2 = 32 (space)\n isepOut = default (isep1)\n   Sres -> '%s'\n", 1, Stray, Sres
Stray     =           "a, b, c, d, e"
isep1     =           32
isep2     =           44
Sres      StrayRev    Stray, isep1, isep2
          printf_i    "\nStray = '%s'\n isep1 = 32 (space)\n isep2 = 44 (comma)\n isepOut = default (isep1)\n   Sres -> '%s'\n", 1, Stray, Sres
Stray     =           "a, b, c, d, e"
isep1     =           32
isep2     =           44
isepOut   =           124
Sres      StrayRev    Stray, isep1, isep2, isepOut
          printf_i    "\nStray = '%s'\n isep1 = 32 (space)\n isep2 = 44 (comma)\n isepOut = 124 ('|')\n   Sres -> '%s'\n", 1, Stray, Sres
          prints      "\n"
  endin

  
  instr StraySub_Ex
prints "\n****************************************************************************\n"
prints "**********************************StraySub**********************************\n"
prints "****************************************************************************\n"
          prints      "   <Sub  StraySub  Stray[, istart[, iend[, isepA[, isepB[, isepOut]]]]]>\n"
          prints      "   <returns a subset of Stray>\n"
Stray     =           "a b c d e"
Sub       StraySub    Stray
          printf_i    "\nStray = '%s'\n istart/iend = default (0/-1)\n isep1/isep2 = default (space/tab)\n isepOut = default (isep1)\n   Sub -> '%s'\n", 1, Stray, Sub
Stray     =           "a    b	c  d           e"
Sub       StraySub    Stray
          printf_i    "\nStray = '%s'\n istart/iend = default (0/-1)\n isep1/isep2 = default (space/tab)\n isepOut = default (isep1)\n   Sub -> '%s'\n", 1, Stray, Sub
Stray     =           "a    b	c  d           e"
istart    =           4
Sub       StraySub    Stray, istart
          printf_i    "\nStray = '%s'\n istart = 4\n iend = default (-1)\n isep1/isep2 = default (space/tab)\n isepOut = default (isep1)\n   Sub -> '%s'\n", 1, Stray, Sub
Stray     =           "a    b	c  d           e"
istart    =           1
iend      =           3
Sub       StraySub    Stray, istart, iend
          printf_i    "\nStray = '%s'\n istart = 1\n iend = 3\n isep1/isep2 = default (space/tab)\n isepOut = default (isep1)\n   Sub -> '%s'\n", 1, Stray, Sub
Stray     =           "a,b,c,d,e"
istart    =           1
iend      =           3
isep1     =           44
Sub       StraySub    Stray, istart, iend, isep1
          printf_i    "\nStray = '%s'\n istart = 1\n iend = 3\n isep1/isep2 = 44 (comma)\n isepOut = default (isep1)\n   Sub -> '%s'\n", 1, Stray, Sub
Stray     =           "a, b, c, d, e"
istart    =           1
iend      =           3
isep1     =           44
isep2     =           32
isepOut   =           124
Sub       StraySub    Stray, istart, iend, isep1, isep2, isepOut
          printf_i    "\nStray = '%s'\n istart = 1\n iend = 3\n isep1= 44 (comma)\nisep2 = 32 (space)\n isepOut = 124 ('|')\n   Sub -> '%s'\n", 1, Stray, Sub
          prints      "\n"
  endin

 
  instr StrayRemDup_Ex
prints "\n****************************************************************************\n"
prints "********************************StrayRemDup*********************************\n"
prints "****************************************************************************\n"
          prints      "   <Srem  StrayRemDup  Stray[, isep1[, isep2]]>\n"
          prints      "   <removes duplicates of elements in Stray>\n"
Stray     =           "a b a c c d e e"
Srem      StrayRemDup Stray
          printf_i    "\nStray = '%s'\n isep1/isep2 = default (space/tab)\n   Srem -> '%s'\n", 1, Stray, Srem
Stray     =           "a,b,a,c,c,d,e,e"
isep1     =           44
Srem      StrayRemDup Stray, isep1
          printf_i    "\nStray = '%s'\n isep1/isep2 = 44 (comma)\n   Srem -> '%s'\n", 1, Stray, Srem
Stray     =           "a, b, a, c, c, d, e, e"
isep1     =           44
isep2     =           32
Srem      StrayRemDup Stray, isep1, isep2
          printf_i    "\nStray = '%s'\n isep1 = 44 (comma)\n isep2 = 32 (space)\n   Srem -> '%s'\n", 1, Stray, Srem
          prints      "\n"
  endin


  instr StrayNumToFt_Ex
prints "\n****************************************************************************\n"
prints "********************************StrayNumToFt********************************\n"
prints "****************************************************************************\n"
          prints      "   <ift,iftlen  StrayNumToFt  Stray[, iftno[, isep1[, isep2]]]>\n"
          prints      "   <converts a Stray (just numbers or simple expressions) to a function table>\n"
Stray     =           "1 2 3 4 5"
ift,iftlen StrayNumToFt Stray
          printf_i    "\nStray = '%s'\n iftno = default (0)\n isep1/isep2 = default (space/tab)\n   ift = %d\n   iftlen = %d\n", 1, Stray, ift, iftlen
          TbDmpSmpS ift, 5, "   table content = "
Stray     =           "1+2.7 2^(1/12) 3.10*65 27%5"
ift,iftlen StrayNumToFt Stray
          printf_i    "\nStray = '%s'\n iftno = default (0)\n isep1/isep2 = default (space/tab)\n   ift = %d\n   iftlen = %d\n", 1, Stray, ift, iftlen
          TbDmpSmpS ift, 5, "   table content = "
Stray     =           "1+2.7 2^(1/12) 3.10*65 27%5"
iftno     =           13
ift,iftlen StrayNumToFt Stray, iftno
          printf_i    "\nStray = '%s'\n iftno = %d\n isep1/isep2 = default (space/tab)\n   ift = %d\n   iftlen = %d\n", 1, Stray, iftno, ift, iftlen
          TbDmpSmpS ift, 5, "   table content = "
Stray     =           "1+2.7, 2^(1/12), 3.10*65, 27%5"
iftno     =           0
ift,iftlen StrayNumToFt Stray, iftno, 44
          printf_i    "\nStray = '%s'\n iftno = %d\n isep1/isep2 = 44 (comma)\n   ift = %d\n   iftlen = %d\n", 1, Stray, iftno, ift, iftlen
          TbDmpSmpS ift, 5, "   table content = "
          prints      "\n"
  endin
  
  
</CsInstruments>
<CsScore>
i "title" 0 .01
i "StrayLen_Ex" .01 .01
i "StrayGetEl_Ex" .02 .01
i "StrayGetNum_Ex" .03 .01
i "StrayElMem_Ex" .04 .01
i "StrayNumMem_Ex" .05 .01
i "StraySetEl_Ex" .06 .01
i "StraySetNum_Ex" .07 .01
i "StrayRev_Ex" .08 .01
i "StraySub_Ex" .09 .01
i "StrayRemDup_Ex" .10 .01
i "StrayNumToFt_Ex" .11 .01
</CsScore>
</CsoundSynthesizer>